import { VueConstructor } from "vue";
import { IPlugin, Editor, SequentialHook, Node } from "@baklavajs/core";
import NodeView from "./components/node/Node.vue";
import NodeOptionView from "./components/node/NodeOption.vue";
import NodeInterfaceView from "./components/node/NodeInterface.vue";
import ConnectionView from "./components/connection/ConnectionView.vue";
export interface IViewNode extends Node {
    position: {
        x: number;
        y: number;
    };
    disablePointerEvents: boolean;
}
export declare class ViewPlugin implements IPlugin {
    type: string;
    editor: Editor;
    panning: {
        x: number;
        y: number;
    };
    scaling: number;
    sidebar: {
        visible: boolean;
        nodeId: string;
        optionName: string;
    };
    options: Record<string, VueConstructor>;
    hooks: {
        renderNode: SequentialHook<NodeView>;
        renderOption: SequentialHook<NodeOptionView>;
        renderInterface: SequentialHook<NodeInterfaceView>;
        renderConnection: SequentialHook<ConnectionView>;
    };
    register(editor: Editor): void;
    registerOption(name: string, component: VueConstructor): void;
}
